using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

namespace DiningPhilosophersSample
{
    internal class Program
    {
        private const uint philosophersCount = 5;

        private static Dictionary<Philosopher, int> eatTimes = new Dictionary<Philosopher, int>();

        private static void Main( string[] args )
        {
            Philosopher[] philosophers = new Philosopher[ philosophersCount ];
            Fork[] forks = new Fork[ philosophersCount ];
            for ( int i = 0; i < philosophers.Length; i++ )
                philosophers[ i ] = new Philosopher();
            for ( int i = 0; i < forks.Length; i++ )
                forks[ i ] = new Fork();

            for ( int i = 0; i < philosophers.Length; i++ )
            {
                eatTimes.Add( philosophers[ i ], 0 );
                philosophers[ i ].Satiated += Program_Satiated;

                philosophers[ i ].Init(
/*                    philosophers[ ( i + philosophersCount - 1 ) % philosophersCount ],
                    philosophers[ ( i + 1 ) % philosophersCount ],
*/                    forks[ i ],
                    forks[ ( i + 1 ) % philosophersCount ],
                    0 == i,
                    philosophersCount - 1 != i );
            }

            foreach ( Philosopher philosopher in philosophers )
                philosopher.Init();

            foreach ( Philosopher philosopher in philosophers )
                philosopher.Start();
        }

        private static void Program_Satiated( Philosopher philosopher )
        {
            if ( null == philosopher )
                return;

            eatTimes[ philosopher ] = eatTimes[ philosopher ] + 1;

            StringBuilder stringBuilder = new StringBuilder( "Philosophers eat times: " );
            Philosopher[] philosophers = new Philosopher[ eatTimes.Keys.Count ];
            eatTimes.Keys.CopyTo( philosophers, 0 );
            for ( int i = 0; i < philosophers.Length; i++ )
                stringBuilder.Append( eatTimes[ philosophers[ i ] ].ToString( "{0} " ) );

            Trace.WriteLine( stringBuilder.ToString() );
        }
    }
}