using Microsoft.VisualStudio.Modeling.Diagrams;

namespace ImTryin.StateMachineDesigner.Designer
{
    public partial class StateShape
    {
        public override bool CanExpandAndCollapse
        {
            get { return false; }
        }

        /// <summary>
        /// Called on every connector creation.
        /// </summary>
        public override bool HasConnectionPoints
        {
            get { return true; }
        }

        /// <summary>
        /// Called on every connector creation.
        /// Should only define connection points once.
        /// </summary>
        /// <param name="link"></param>
        public override void CreateConnectionPoint( LinkShape link )
        {
            if ( ConnectionPoints == null || ConnectionPoints.Count == 0 )
            {
                // Contrary to appearances, connection points aren't specific to link type.
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 0.0, AbsoluteBoundingBox.Y + 0.25 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 0.0, AbsoluteBoundingBox.Y + 0.5 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 0.0, AbsoluteBoundingBox.Y + 0.75 ), link );

                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 2.0, AbsoluteBoundingBox.Y + 0.25 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 2.0, AbsoluteBoundingBox.Y + 0.5 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 2.0, AbsoluteBoundingBox.Y + 0.75 ), link );

                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 0.5, AbsoluteBoundingBox.Y + 0.0 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 1.0, AbsoluteBoundingBox.Y + 0.0 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 1.5, AbsoluteBoundingBox.Y + 0.0 ), link );

                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 0.5, AbsoluteBoundingBox.Y + 1.0 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 1.0, AbsoluteBoundingBox.Y + 1.0 ), link );
                CreateConnectionPoint( new PointD( AbsoluteBoundingBox.X + 1.5, AbsoluteBoundingBox.Y + 1.0 ), link );
            }
        }
    }
}