using System;
using ImTryin.StateMachineDesigner.DomainModel;
using Microsoft.VisualStudio.Modeling;

namespace ImTryin.StateMachineDesigner.Designer
{
    //[RuleOn( typeof ( Transition ), FireTime = TimeToFire.TopLevelCommit )]
    //public sealed class DomainModelTransitionAddRule : AddRule
    //{
    //    public override void ElementAdded( ElementAddedEventArgs e )
    //    {
    //        Transition transition = (Transition) e.ModelElement;

    //        if ( null == transition.StateMachine )
    //        {
    //            if ( transition.TransitionFrom.StateMachine == transition.TransitionTo.StateMachine )
    //                transition.StateMachine = transition.TransitionFrom.StateMachine;
    //            else
    //                throw new 
    //        }
    //    }
    //}

    //[RuleOn( typeof ( Transition ), FireTime = TimeToFire.TopLevelCommit )]
    //public sealed class DomainModelTransitionRemovingRule : RemovingRule
    //{
    //    public override void ElementRemoving( ElementRemovingEventArgs e )
    //    {
    //        Transition transition = (Transition) e.ModelElement;
    //        if ( null != transition.StateMachine )
    //            transition.StateMachine = null;
    //    }
    //}

    [RuleOn( typeof ( Transition ), FireTime = TimeToFire.TopLevelCommit )]
    public sealed class DomainModelTransitionChangeRule : ChangeRule
    {
        public override void ElementAttributeChanged( ElementAttributeChangedEventArgs e )
        {
            Transition transition = (Transition) e.ModelElement;

            if ( e.MetaAttribute.Id == Transition.TriggerMetaAttributeGuid )
                transition.Event = transition.TransitionFrom.StateMachine.CodeGeneration.GetEvent( transition.Trigger );

            if ( e.MetaAttribute.Id == Transition.GuardMetaAttributeGuid )
                transition.Condition =
                    transition.TransitionFrom.StateMachine.CodeGeneration.GetCondition( transition.Guard );

            if ( e.MetaAttribute.Id == Transition.ActivityMetaAttributeGuid )
                transition.Statement =
                    transition.TransitionFrom.StateMachine.CodeGeneration.GetStatement( transition.Activity );

            if ( ( e.MetaAttribute.Id == Transition.TriggerMetaAttributeGuid ) ||
                 ( e.MetaAttribute.Id == Transition.GuardMetaAttributeGuid ) ||
                 ( e.MetaAttribute.Id == Transition.ActivityMetaAttributeGuid ) )
            {
                string notationProperty = transition.Trigger;
                if ( "" != transition.Guard )
                    notationProperty += "[" + transition.Guard + "]";
                if ( "" != transition.Activity )
                    notationProperty += "/" + transition.Activity;
                transition.Notation = notationProperty;
            }
        }
    }

    internal static partial class GeneratedMetaModelTypes
    {
        //internal static Type DomainModelTransitionAddRuleType =
        //    typeof ( DomainModelTransitionAddRule );

        //internal static Type DomainModelTransitionRemovingRuleType =
        //    typeof ( DomainModelTransitionRemovingRule );

        internal static Type DomainModelTransitionChangeRuleType =
            typeof ( DomainModelTransitionChangeRule );
    }
}