
//------------------------------------------------------------------------------
// HT002 - add menu commands.
// This template has been modified to make it easier to add new menu commands.
// Search for HT002 in this file to find the changes.

// Summary of changes:
// 1) Changed the original "CommandSet" class to an abstract class called "BaseCommandSet".
// 2) Added a new concrete class called "CommandSet" that derives from "BaseCommandSet".

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace ImTryin.StateMachineDesigner.Designer
	{
	#region Using Directives
	using System;
	using System.Collections;
	using System.ComponentModel.Design;
	using System.Diagnostics;
	using System.Drawing;
	using System.Globalization;
	using System.Runtime.InteropServices;
	using System.Windows.Forms;
	using System.IO;			// for FileInfo, Path
	using Microsoft.VisualStudio.Modeling;
	using Microsoft.VisualStudio.Modeling.Validation;
	using Microsoft.VisualStudio.Modeling.Diagrams;
	using Microsoft.VisualStudio.EnterpriseTools.Shell;
	using Microsoft.VisualStudio.Shell;
	#endregion


	/// <summary>
	/// HT002: New concrete class so you can override the 
	///  "GetMenuCommands" to add your own menu commands.
	/// </summary>
	internal partial class CommandSet : BaseCommandSet
	{
		// To add new menu commands, override "GetMenuCommands"
		// and add handlers for your new items.
		// Don't forget to call the base class "GetMenuCommands"
		// method, otherwise the normal DSL menu commands
		// (Delete, Add, Validate etc) won't be added.

		/// <summary>
		/// HT002: define a new constructor to match the base class constructor
		/// </summary>
		public CommandSet (IServiceProvider serviceProvider) : base(serviceProvider)
		{
		}

	}


	/// <summary>
	/// Commands supported by this designer
	/// </summary>
	//HT002: change the class to be an abstract class. Prefixed the
	// class name with "Base"
	internal abstract class BaseCommandSet : Microsoft.VisualStudio.Modeling.Utilities.CommandSet
	{
		#region Constructor
		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="serviceProvider"></param>
		//HT002: prefixed the constructor name with "Base"
		// to match the new class name.
		public BaseCommandSet (IServiceProvider serviceProvider) : base(serviceProvider)
		{
		}
		#endregion

		/// <summary>
		/// Provide the menu commands that this command set handles
		/// </summary>
		/// <param name="commandList"></param>
		protected override void GetMenuCommands(IList commandList)
		{
			// Get the standard commands
			base.GetMenuCommands(commandList);

			// Add View Model Explorer command in the top-level menu.
			// Use a ContextBoundMenuCommand for this, because availability of the command is
			// based on whether or not the command context of our editor is active. 
			MenuCommand menuCommand = new CommandContextBoundMenuCommand(this.ServiceProvider, 
				new EventHandler(OnMenuViewModelExplorer), 
				new CommandID(GuidList.guidStateMachineLanguageCmdSet, (int)PackageCommandIdList.cmdIdViewExplorer),
				GuidList.guidEditorFactory);

			commandList.Add(menuCommand);
			
			// Add validation menu command
			menuCommand = new DynamicStatusMenuCommand(new EventHandler(OnStatusValidate), new EventHandler(OnMenuValidate), CommonModelingCommands.ValidateModel);
			commandList.Add(menuCommand);
			
		}

		/// <summary>
		/// Show the Model Explorer
		/// </summary>
		/// <param name="sender">The source of the event</param>
		/// <param name="e">The event parameters</param>
		internal void OnMenuViewModelExplorer (object sender, EventArgs e)
		{
			StateMachineLanguageModelExplorer explorer = this.ModelExplorer;
			if ( explorer != null )
			{
				explorer.Show();
			}
		}


		/// <summary>
		/// Status event handler for validating the model
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		internal void OnStatusValidate(object sender, EventArgs e)
		{
			MenuCommand cmd = sender as MenuCommand;
			cmd.Enabled = cmd.Visible = true;
		}

		/// <summary>
		/// Handler for validating the model
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		internal void OnMenuValidate(object sender, EventArgs e)
		{
			if (this.CurrentData != null && this.CurrentData.Store != null)
			{
				ValidationCategory category = ValidationCategory.Menu;
#if DEBUG
				category |= ValidationCategory.Debug;
#endif
				this.CurrentData.ValidationController.Validate(this.CurrentData.Store, category);
			}
		}


		/// <summary>
		/// Currently focused document
		/// </summary>
		internal StateMachineLanguageDocData CurrentData
		{
			get
			{
				return this.MonitorSelection.CurrentDocument as StateMachineLanguageDocData;
			}
		}

		/// <summary>
		/// Currently focused document view
		/// </summary>
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode")]
		internal StateMachineLanguageDocView CurrentView
		{
			get
			{
				return base.CurrentDocView as StateMachineLanguageDocView;
			}
		}

		/// <summary>
		/// Browser tool window.
		/// </summary>
		internal StateMachineLanguageModelExplorer ModelExplorer
		{
			get
			{
				return base.ModelExplorerToolWindow as StateMachineLanguageModelExplorer;
			}
		}

		/// <summary>
		/// Provide the concrete type that implements the model explorer in this designer
		/// </summary>
		/// <value>The model explorer's concrete type</value>
		protected override Type ModelExplorerType
		{
			get
			{
				return typeof(StateMachineLanguageModelExplorer);
			}
		}
	}
}

