using System.Diagnostics;
using System.IO;
using System.Runtime.InteropServices;
using ImTryin.StateMachineDesigner.Designer.Diagram;
using Microsoft.VisualStudio.EnterpriseTools.Shell;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace ImTryin.StateMachineDesigner.Designer.TextTemplates
{
    [Guid( "24221BFC-060B-450b-8D0C-A254534D6226" )]
    [
        ProvideCodeGenerator( typeof ( DirectCodeGenerator ), "StateMachineGenerator",
            "Custom tool that generates files based on my DSL", true )]
    public class DirectCodeGenerator : TemplatedCodeGenerator
    {
        protected override byte[] GenerateCode( string inputFileName, string inputFileContent )
        {
            const string FILENAME_MARKER = "%MODELFILENAME%";

            Debug.Assert( Designer_Resource.StateMachineTemplate.Contains( FILENAME_MARKER ),
                          "Error - could not find a file name marker in the template" );

            inputFileContent =
                Designer_Resource.StateMachineTemplate.Replace( FILENAME_MARKER, Path.GetFileName( inputFileName ) );

            return base.GenerateCode( inputFileName, inputFileContent );
        }
    }
}