namespace ImTryin.StateMachineDesigner.DomainModel
{
    public partial class CodeGeneration
    {
        public Event GetEvent( string access )
        {
            if ( "" == access )
                return null;

            foreach ( Event oEvent in Events )
            {
                if ( access == oEvent.Access )
                    return oEvent;
            }

            Event newEvent = Event.CreateEvent( Store );
            newEvent.Access = access;
            newEvent.CodeGeneration = this;
            return newEvent;
        }

        public Condition GetCondition( string notation )
        {
            if ( "" == notation )
                return null;

            foreach ( Condition condition in Conditions )
            {
                if ( notation == condition.Notation )
                    return condition;
            }

            Condition newCondition = Condition.CreateCondition( Store );
            newCondition.Notation = notation;
            newCondition.CodeGeneration = this;
            return newCondition;
        }

        public Statement GetStatement( string notation )
        {
            if ( "" == notation )
                return null;

            foreach ( Statement statement in Statements )
            {
                if ( notation == statement.Notation )
                    return statement;
            }

            Statement newStatement = Statement.CreateStatement( Store );
            newStatement.Notation = notation;
            newStatement.CodeGeneration = this;
            return newStatement;
        }
    }
}