using System;

namespace ImTryin.StateMachineDesigner.DomainModel
{
    public partial class State
    {
        public string GetActivity( StateActivityType type )
        {
            foreach ( StateActivity stateActivity in Activities )
            {
                if ( type == stateActivity.Type )
                    return stateActivity.Activity;
            }
            throw new IndexOutOfRangeException( "State hasn't activity with such type!" );
        }

        public void SetActivity( string activity, StateActivityType type )
        {
            foreach ( StateActivity stateActivity in Activities )
            {
                if ( type == stateActivity.Type )
                    stateActivity.Activity = activity;
            }
            throw new IndexOutOfRangeException( "State hasn't activity with such type!" );
        }

        public string EntryActivity
        {
            get { return GetActivity( StateActivityType.Entry ); }
            set { SetActivity( value, StateActivityType.Entry ); }
        }

        public string IncludeActivity
        {
            get { return GetActivity( StateActivityType.Include ); }
            set { SetActivity( value, StateActivityType.Include ); }
        }

        public string ExitActivity
        {
            get { return GetActivity( StateActivityType.Exit ); }
            set { SetActivity( value, StateActivityType.Exit ); }
        }
    }
}