using System.Diagnostics;
using Microsoft.VisualStudio.Modeling.Validation;

namespace ImTryin.StateMachineDesigner.DomainModel
{
    [ValidationState( ValidationState.Enabled )]
    public partial class State
    {
        [ValidationMethod( ValidationCategory.Menu | ValidationCategory.Open | ValidationCategory.Save )]
        private void ValidateStateActivities( ValidationContext context )
        {
            if ( 3 != Activities.Count )
            {
                Debug.Fail( "State has wrong activities count!" );
                context.LogError( "State has wrong activities count", "StateActivitiesWrong", this );
            }
            else
            {
                if ( StateActivityType.Entry != Activities[ 0 ].Type )
                {
                    Debug.Fail( "State has wrong entry activity type!" );
                    context.LogError( "State has wrong entry activity type", "StateActivitiesWrong", this );
                }
                /*
                else if ( !Validation.Artefacts.CheckStatement( this.Activities[ 0 ].Activity, this.StateMachine ) )
                    context.LogError( "State entry activity isn't valid", "StateActivitiesWrong", this );
                */

                if ( StateActivityType.Include != Activities[ 1 ].Type )
                {
                    Debug.Fail( "State has wrong include activity type!" );
                    context.LogError( "State has wrong include activity type", "StateActivitiesWrong", this );
                }
                /*
                else if ( !Validation.Artefacts.CheckStateMachine( this.Activities[ 1 ].Activity, this.StateMachine ) )
                    context.LogError( "State include activity isn't valid", "StateActivitiesWrong", this );
                */

                if ( StateActivityType.Exit != Activities[ 2 ].Type )
                {
                    Debug.Fail( "State has wrong exit activity type!" );
                    context.LogError( "State has wrong exit activity type", "StateActivitiesWrong", this );
                }
                /*
                else if ( !Validation.Artefacts.CheckStatement( this.Activities[ 2 ].Activity, this.StateMachine ) )
                    context.LogError( "State exit activity isn't valid", "StateActivitiesWrong", this );
                */
            }
        }
    }
}